#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <gtk/gtk.h>
#include "Yajin.h"
#include "yCursor.h"

Yajin*     yajin;
yCursor*   cursor;

int        x = 50;
int        y = 50;

#define BITMAP_WIDTH  64
#define BITMAP_HEIGHT 64
#define MOVE_SPEED    12
#define BALL_SPEED    128

#define OFFSET_X (0)
#define OFFSET_Y (6)

static int new_xy(int cursor_x, int cursor_y)
{
    int    diff_x, diff_y;
    double d, move_total;
    diff_x = ((cursor_x+OFFSET_X) - x - BITMAP_WIDTH/2);
    diff_y = ((cursor_y+OFFSET_Y) - y - BITMAP_HEIGHT);
    d      = (diff_x*diff_x) + (diff_y*diff_y);
    if (d == 0)
    {
        return 0;
    }
    move_total = sqrt(d);
    if (move_total <= MOVE_SPEED)
    {
        x += diff_x;
        y += diff_y;
    }
    else
    {
        x += (int)((MOVE_SPEED*diff_x) / move_total);
        y += (int)((MOVE_SPEED*diff_y) / move_total);
    }
    return 1;
}

static void move_cursor(int cursor_x, int cursor_y)
{
    int    move_total;
    int    ratio_x, ratio_y;
    int    diff_x, diff_y;
    struct timeval t;
    int    course;

    gettimeofday(&t, NULL);
    srand(t.tv_usec);
    move_total = rand() % BALL_SPEED;
    course     = rand() % 360;
    if (course < 90)
    {
        ratio_x = course;
        ratio_y = (course-90);
    }
    else if (course < 180)
    {
        ratio_x = -(course-180);
        ratio_y = (course-90);
    }
    else if (course < 270)
    {
        ratio_x = -(course-180);
        ratio_y = -(course-270);
    }
    else
    {
        ratio_x = (course-360);
        ratio_y = (270-course);
    }
    diff_x    = move_total * ratio_x / 90;
    diff_y    = move_total * ratio_y / 90;
    cursor_x += diff_x;
    cursor_y += diff_y;
    cursor->Move(cursor_x, cursor_y);
}
 
static gint cb_timeout2(gpointer)
{
    int    cursor_x, cursor_y;
    gdk_window_get_pointer(NULL, &cursor_x, &cursor_y, NULL);
    if (new_xy(cursor_x, cursor_y))
    {
        yajin->Move(x, y);
    }
    else
    {
        move_cursor(cursor_x, cursor_y);
    }
    return 1;
}

static int init(int argc, char** argv)
{
//    gtk_set_locale();
    gtk_init(&argc, &argv);
    return 0;
}

int main(int argc, char** argv)
{
    init(argc, argv);
    yajin = new Yajin();
    yajin->TimeoutAdd(200, cb_timeout2);
    yajin->Move(x, y);
    cursor = new yCursor(yajin->GetWindow());
    gtk_main();
    return 0;
}
