#include "yCursor.h"

#include "images/ball.xbm"
#include "images/ball_mask.xbm"
#define XBM_SOURCE ball_bits
#define XBM_MASK   ball_mask_bits
#define XBM_WIDTH  ball_width
#define XBM_HEIGHT ball_height
#define HOTSPOT_X  12
#define HOTSPOT_Y  12

yCursor::yCursor(GtkWidget* window)
{
    CreateCursor(window);
#if 1
    gdk_window_set_cursor(window->window, cursor);
#else
    XDefineCursor(GDK_DISPLAY(), GDK_ROOT_WINDOW(),
                  ((GdkCursorPrivate*)cursor)->xcursor);
#endif
    gdk_cursor_destroy(cursor);
}

yCursor::~yCursor()
{
}

void yCursor::CreateCursor(GtkWidget* window)
{
    GdkBitmap* source;
    GdkBitmap* mask;
    GdkColor   white;
    GdkColor   black;
    source = gdk_bitmap_create_from_data(window->window, XBM_SOURCE,
                                         XBM_WIDTH, XBM_HEIGHT);
    mask = gdk_bitmap_create_from_data(window->window, XBM_MASK,
                                       XBM_WIDTH, XBM_HEIGHT);
    white.red   = 65535;
    white.green = 65535;
    white.blue  = 65535;
    black.red   = 0;
    black.green = 0;
    black.blue  = 0;
    cursor = gdk_cursor_new_from_pixmap(source, mask,
                                        &black, &white,
                                        HOTSPOT_X, HOTSPOT_Y);
}

void yCursor::Move(int x, int y)
{
    XWarpPointer(GDK_DISPLAY(), None, GDK_ROOT_WINDOW(),
                 0, 0, 0, 0, x, y);
}
